<template>
    <div class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-12">
                    <h1 class="m-0 mb-4">Create Product</h1>
                </div>

                <div class="col-sm-12">
                    <div class="card">
                        <div class="card-body row">

                            <div class="col-sm-6">
                                <form>
                                    <div class="mb-3">
                                        <label for="name" class="form-label">Name</label>
                                        <input type="text" class="form-control" id="name" v-model="name">
                                    </div>
                                    <div class="mb-3">
                                        <label for="name" class="form-label">Category</label>
                                        <select class="form-control" v-model="category">
                                            <option value="Food">Food</option>
                                            <option value="Car">Car</option>
                                            <option value="Candy">Candy</option>
                                            <option value="Computer">Computer</option>
                                            <option value="Motor">Motor</option>
                                    </select>
                                    </div>

                                    <div class="mb-3">
                                        <div class="form-floating">
                                            <label for="floatingTextarea2">Comments</label>
                                            <textarea 
                                                class="form-control" 
                                                placeholder="Leave a comment here" 
                                                id="floatingTextarea2" 
                                                style="height: 100px"
                                                v-model="description"
                                            >
                                            </textarea>
                                        </div>
                                    </div>

                                    <div class="mb-3">
                                        <label for="formFile" class="form-label">Product images</label>
                                        <input class="form-control" type="file" id="formFileMultiple" @change="file" multiple accept="image/*">
                                    </div>
                                    
                                    <div class="mb-3">
                                        <label for="formDatePicker" class="form-label">Date and Time</label>
                                        <Datepicker v-model="dateTime" hide-offset-dates />
                                    </div>
                                    
                                    <button @click="createProduct" type="button" class="btn btn-primary">Submit</button>
                                    <a href="/products" class="btn btn-warning ml-3">Cancel</a>
                                </form>
                            </div>

                            <div class="col-sm-6">
                                <div class="row">
                                    <div class="col-sm-3" v-for="(url, index) in preview" :key="index">
                                        <img :src="url" class="previewimage" />
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div> 


            </div>
        </div>
    </div>
</template>

<script>
import Datepicker from '@vuepic/vue-datepicker';
import '@vuepic/vue-datepicker/dist/main.css';
import moment from 'moment' ;

export default {
    components: { 
        Datepicker,
    },
    data() {
        return {
            name: '',
            category: '',
            description: '',
            image: {},
            dateTime: '',
            preview: []
        }
    },
    mounted() {
        this.checkProduct()
    },
    methods: {
        createProduct() {
            const formData = new FormData();
            const id = this.$route.params.id || '';

            formData.append('name', this.name);
            formData.append('category', this.category);
            formData.append('description', this.description);
            formData.append('dateTime', moment(this.dateTime).format());

            for (var i = 0; i < this.image.length; i++){
                formData.append(`image[${i}]`, this.image[i]);
            }
            axios.post('/api/products/' + id , formData)
            .then(() => {
                window.location.href = '/products'
            })

        },
        file(e) {
            this.image = e.target.files
            this.preview = []
            for (var i = 0; i < this.image.length; i++){
                this.preview.push(URL.createObjectURL(this.image[i]))
            }
        },
        checkProduct() {
            const id = this.$route.params.id
            
            if(!this.$route.params.id) return;

            axios.get('/api/products/' + id)
            .then((response) => {
                this.name = response.data.name
                this.category = response.data.category
                this.description = response.data.description
                this.dateTime = response.data.date_time
            });
        },
    },
    
};
</script>

<style scoped>
.previewimage {
    width: 100%;
    height: 150px;
    object-fit: cover;
}
</style>